local _, namespace = ... 	--localization
local L = namespace.L 				--localization

local _, gdbprivate = ...
gdbprivate.gdbdefaults.gdbdefaults.dejacharacterstatsExpandChecked = {
		ExpandSetChecked = true,
}

gdbprivate.gdbdefaults.gdbdefaults.dejacharacterstatsExpandButtonChecked = {
		ExpandButtonSetChecked = true,
}

gdbprivate.gdbdefaults.gdbdefaults.dejacharacterstatsExpandButtonAltPlacementChecked = {
	ExpandButtonAltPlacementSetChecked = false,
}

-- ------------------------------------------------
-- -- DCS Character Frame Expand/Collapse Button --
-- ------------------------------------------------
local DCS_tooltipText
local PaperDollFrame = PaperDollFrame
local CharacterFrame = CharacterFrame

local function DCS_CharacterFrame_Expand()
	DCS_StatScrollFrame:Show()
end

local function DCS_CharacterFrame_Collapse()
	DCS_StatScrollFrame:Hide()
end

local function DCS_ExpandCheck_OnEnter(self)
	GameTooltip:SetOwner(PaperDollFrame.ExpandButton, "ANCHOR_RIGHT");
	GameTooltip:SetText(DCS_tooltipText, 1, 1, 1, 1, true)
	GameTooltip:Show()
end

local function DCS_ExpandCheck_OnLeave(self)
	GameTooltip_Hide()
 end

local function DCS_TalentMove(RelevantFramexOffset)
	local Talentpoint, TalentrelativeTo, TalentrelativePoint, TalentxOffset, TalentyOffset = 0,0,0,0,0
	local Talentpoint, TalentrelativeTo, TalentrelativePoint, TalentxOffset, TalentyOffset = TalentFrame:GetPoint(1)
	if ( TalentrelativeTo ) then
		TalentrelativeTo = TalentrelativeTo:GetName();
	else
		TalentrelativeTo = TalentFrame:GetParent():GetName();
	end
	TalentFrame:ClearAllPoints()		
	TalentFrame:SetPoint(
		Talentpoint,
		TalentrelativeTo, 
		TalentrelativePoint, 
		(RelevantFramexOffset + 567), 
		TalentyOffset)
end

local function DCS_CraftMove(RelevantFramexOffset)
	local Craftpoint, CraftrelativeTo, CraftrelativePoint, CraftxOffset, CraftyOffset = 0,0,0,0,0
	local Craftpoint, CraftrelativeTo, CraftrelativePoint, CraftxOffset, CraftyOffset = CraftFrame:GetPoint(1)
	if ( CraftrelativeTo ) then
		CraftrelativeTo = CraftrelativeTo:GetName();
	else
		CraftrelativeTo = TalentFrame:GetParent():GetName();
	end
	CraftFrame:ClearAllPoints()		
	CraftFrame:SetPoint(
		Craftpoint,
		CraftrelativeTo, 
		CraftrelativePoint, 
		(RelevantFramexOffset + 567), 
		CraftyOffset)
	if TalentFrame and TalentFrame:IsVisible()then
		DCS_TalentMove(CraftxOffset - 198)
	end
end

local function DCS_TradeSkillMove(RelevantFramexOffset)
	local TradeSkillpoint, TradeSkillrelativeTo, TradeSkillrelativePoint, TradeSkillxOffset, TradeSkillyOffset = 0,0,0,0,0
	local TradeSkillpoint, TradeSkillrelativeTo, TradeSkillrelativePoint, TradeSkillxOffset, TradeSkillyOffset = TradeSkillFrame:GetPoint(1)
	if ( TradeSkillrelativeTo ) then
		TradeSkillrelativeTo = TradeSkillrelativeTo:GetName();
	else
		TradeSkillrelativeTo = TalentFrame:GetParent():GetName();
	end
	TradeSkillFrame:ClearAllPoints()		
	TradeSkillFrame:SetPoint(
		TradeSkillpoint,
		TradeSkillrelativeTo, 
		TradeSkillrelativePoint, 
		(RelevantFramexOffset + 567), 
		TradeSkillyOffset)	
	if CraftFrame and CraftFrame:IsVisible() then
		DCS_CraftMove(TradeSkillxOffset - 198)
	elseif TalentFrame and TalentFrame:IsVisible() then
		DCS_TalentMove(TradeSkillxOffset - 198)
	end
end

local function DCS_HiddenMoveTalentFrameBack(Frame)
	Frame:ClearAllPoints()		
	Frame:SetPoint(
		"TOPLEFT",
		UIParent, 
		"TOPLEFT", 
		369.00003051758, 
		-104.00000762939)
end

local function DCS_ShownMoveTalentFrame()
	local checked = gdbprivate.gdb.gdbdefaults.dejacharacterstatsExpandChecked.ExpandSetChecked
	local PaperDollpoint, PaperDollrelativeTo, PaperDollrelativePoint, PaperDollxOffset, PaperDollyOffset = PaperDollFrame:GetPoint(1)
	if ( PaperDollrelativeTo ) then
		PaperDollrelativeTo = PaperDollrelativeTo:GetName();
	else
		PaperDollrelativeTo = TalentFrame:GetParent():GetName();
	end
	-- print(PaperDollpoint, PaperDollrelativeTo, PaperDollrelativePoint, PaperDollxOffset, PaperDollyOffset)
	if checked == true then
		if TradeSkillFrame and TradeSkillFrame:IsVisible() then
			DCS_TradeSkillMove(PaperDollxOffset)
		elseif CraftFrame and CraftFrame:IsVisible() then
			DCS_CraftMove(PaperDollxOffset)
		elseif TalentFrame and TalentFrame:IsVisible() then
			DCS_TalentMove(PaperDollxOffset)
		end
	else
		if TradeSkillFrame and TradeSkillFrame:IsVisible() then
			DCS_TradeSkillMove(PaperDollxOffset - 198)
		elseif CraftFrame and CraftFrame:IsVisible() then
			DCS_CraftMove(PaperDollxOffset - 198)
		elseif TalentFrame and TalentFrame:IsVisible() then
			DCS_TalentMove(PaperDollxOffset - 198)
		end
	end		
end

	PaperDollFrame.ExpandButton = CreateFrame("Button", nil, PaperDollFrame)
	PaperDollFrame.ExpandButton:SetSize(32, 32)
	PaperDollFrame.ExpandButton:SetHighlightTexture("Interface\\BUTTONS\\UI-Common-MouseHilight")
	
	PaperDollFrame.ExpandButton:SetScript("OnEnter", DCS_ExpandCheck_OnEnter)
	PaperDollFrame.ExpandButton:SetScript("OnLeave", DCS_ExpandCheck_OnLeave)
			 
	PaperDollFrame.ExpandButton:SetScript("OnMouseUp", function (self)
		local checked = gdbprivate.gdb.gdbdefaults.dejacharacterstatsExpandChecked.ExpandSetChecked
		if checked == true then
			DCS_CharacterFrame_Collapse()
			C_Timer.NewTicker(0.125, DCS_ShownMoveTalentFrame, 5) -- This fires 5 more times after the OnUpdate stops to push the remaining frames into palce.
			self:SetNormalTexture("Interface\\BUTTONS\\UI-SpellbookIcon-NextPage-Up")
			self:SetPushedTexture("Interface\\BUTTONS\\UI-SpellbookIcon-NextPage-Down")
			DCS_tooltipText = L['Show Character Stats'] --Creates a tooltip on mouseover.
			gdbprivate.gdb.gdbdefaults.dejacharacterstatsExpandChecked.ExpandSetChecked = false
		else
			DCS_CharacterFrame_Expand()
			self:SetNormalTexture("Interface\\BUTTONS\\UI-SpellbookIcon-PrevPage-Up")
			self:SetPushedTexture("Interface\\BUTTONS\\UI-SpellbookIcon-PrevPage-Down")
			DCS_tooltipText = L['Hide Character Stats'] --Creates a tooltip on mouseover.
			gdbprivate.gdb.gdbdefaults.dejacharacterstatsExpandChecked.ExpandSetChecked = true
		end
		DCS_ExpandCheck_OnEnter()
		DCS_ShownMoveTalentFrame()
	end)

	PaperDollFrame:HookScript("OnShow", function(self)
		local checked = gdbprivate.gdb.gdbdefaults.dejacharacterstatsExpandChecked.ExpandSetChecked
		if checked == true then
			DCS_CharacterFrame_Expand()
			PaperDollFrame.ExpandButton:SetNormalTexture("Interface\\BUTTONS\\UI-SpellbookIcon-PrevPage-Up")
			PaperDollFrame.ExpandButton:SetPushedTexture("Interface\\BUTTONS\\UI-SpellbookIcon-PrevPage-Down")
			DCS_tooltipText = L['Hide Character Stats'] --Creates a tooltip on mouseover.
		else
			DCS_CharacterFrame_Collapse()
			PaperDollFrame.ExpandButton:SetNormalTexture("Interface\\BUTTONS\\UI-SpellbookIcon-NextPage-Up")
			PaperDollFrame.ExpandButton:SetPushedTexture("Interface\\BUTTONS\\UI-SpellbookIcon-NextPage-Down")
			DCS_tooltipText = L['Show Character Stats'] --Creates a tooltip on mouseover.
		end
	end)

	PaperDollFrame.elapsed = 0.125 -- run the update code 8 times per second
	PaperDollFrame:HookScript("OnUpdate", function(self, elapsed)
		self.elapsed = self.elapsed - elapsed
		if self.elapsed > 0 then return end
		self.elapsed = 0.125
		local checked = gdbprivate.gdb.gdbdefaults.dejacharacterstatsExpandChecked.ExpandSetChecked
		if checked == true then
			if PaperDollFrame:IsVisible() then
				DCS_ShownMoveTalentFrame()
			end		
		end
	end)

--------------------------
-- Toggle Expand Button --
--------------------------

local DCS_ExpandButtonCheck = CreateFrame("CheckButton", "DCS_ExpandButtonCheck", DejaClassicStatsPanel, "InterfaceOptionsCheckButtonTemplate")
	DCS_ExpandButtonCheck:RegisterEvent("PLAYER_LOGIN")
	DCS_ExpandButtonCheck:ClearAllPoints()
	DCS_ExpandButtonCheck:SetPoint("TOPLEFT", "dcsMiscPanelCategoryFS", 7, -55)
	DCS_ExpandButtonCheck:SetScale(1)
	DCS_ExpandButtonCheck.tooltipText = L['Displays the Expand button for the character stats frame.'] --Creates a tooltip on mouseover.
	_G[DCS_ExpandButtonCheck:GetName() .. "Text"]:SetText(L["Expand"])
	
	DCS_ExpandButtonCheck:SetScript("OnEvent", function(self, event)
		if event == "PLAYER_LOGIN" then
			local checked = gdbprivate.gdb.gdbdefaults.dejacharacterstatsExpandButtonChecked.ExpandButtonSetChecked
			self:SetChecked(checked)
			if checked then
				PaperDollFrame.ExpandButton:Show()
			else
				PaperDollFrame.ExpandButton:Hide()
			end
		end
	end)

	DCS_ExpandButtonCheck:SetScript("OnClick", function(self)
		local checked = self:GetChecked()
		gdbprivate.gdb.gdbdefaults.dejacharacterstatsExpandButtonChecked.ExpandButtonSetChecked = checked
		if checked then
			PaperDollFrame.ExpandButton:Show()
		else
			PaperDollFrame.ExpandButton:Hide()
		end
	end)

----------------------------------------------
-- Toggle Expand Button Alternate Placement --
----------------------------------------------

local DCS_ExpandButtonAltPlacementCheck = CreateFrame("CheckButton", "DCS_ExpandButtonAltPlacementCheck", DejaClassicStatsPanel, "InterfaceOptionsCheckButtonTemplate")
	DCS_ExpandButtonAltPlacementCheck:RegisterEvent("PLAYER_LOGIN")
	DCS_ExpandButtonAltPlacementCheck:ClearAllPoints()
	DCS_ExpandButtonAltPlacementCheck:SetPoint("TOPLEFT", "dcsMiscPanelCategoryFS", 7, -75)
	DCS_ExpandButtonAltPlacementCheck:SetScale(1)
	DCS_ExpandButtonAltPlacementCheck.tooltipText = L["Displays the Expand button above the hands item slot."] --Creates a tooltip on mouseover.
	_G[DCS_ExpandButtonAltPlacementCheck:GetName() .. "Text"]:SetText(L["Alternate Expand"])
	
	DCS_ExpandButtonAltPlacementCheck:SetScript("OnEvent", function(self, event)
		if event == "PLAYER_LOGIN" then
			local checked = gdbprivate.gdb.gdbdefaults.dejacharacterstatsExpandButtonAltPlacementChecked.ExpandButtonAltPlacementSetChecked
			self:SetChecked(checked)
			if checked then
				PaperDollFrame.ExpandButton:SetPoint("BOTTOMRIGHT", CharacterHandsSlot, "TOPRIGHT", 2, -3)
			else
				PaperDollFrame.ExpandButton:SetPoint("TOPRIGHT", CharacterTrinket1Slot, "BOTTOMRIGHT", 2, -3)
			end
		end
	end)

	DCS_ExpandButtonAltPlacementCheck:SetScript("OnClick", function(self)
		local checked = self:GetChecked()
		gdbprivate.gdb.gdbdefaults.dejacharacterstatsExpandButtonAltPlacementChecked.ExpandButtonAltPlacementSetChecked = checked
		if checked then
			PaperDollFrame.ExpandButton:ClearAllPoints()
			PaperDollFrame.ExpandButton:SetPoint("BOTTOMRIGHT", CharacterHandsSlot, "TOPRIGHT", 2, 3)
		else
			PaperDollFrame.ExpandButton:ClearAllPoints()
			PaperDollFrame.ExpandButton:SetPoint("TOPRIGHT", CharacterTrinket1Slot, "BOTTOMRIGHT", 2, -3)
		end
	end)